 ![Logo](https://roycms.github.io/IosCodeSpecification/logo.png)
# Ios Code Specification
* 我们面对 "别人" 的代码总是相互吐槽，互相"伤害"，一脸的无奈表情就像上面的🍅 tomato.
* 开发一旦涉及到多人协作，我们通常会制定一些规范（也可叫做基于团队的风格和偏好）不管是口头的还是文档形式的还是公司层面的或者是团队层面的，
面对这些规范或风格往往会收到很多的吐槽.
* 你不妨看看 [[来自Google的原文是出自MarkCC的吐槽]](why.md) 进一步了解规范的必要性.
* 面对吐槽，我们还是要有效的开展工作，此时团队需要有一个规范去引导团队按照统一的风格进行编码，团队的新成员加入时你就要给他准备一份这样的告知手册.
* 刚好这里有一份这样的手册，在工作之余搜集整理的一些适合自己团队开发的一些规范，分享这样一个手册，希望它也能为你的团队带来帮助，如果你有新的建议也希望能够 @roycms 我 或者 pull request.

# 手册目录

* [前言](why.md)
* IOS规范
    * [Xcode 工程规范](xcode-project.md)     
    * [Xcode 快捷键](xcodeShortcuts.md)  
    * [方法命名推荐](naming-methods.md)
    * [Objective-C 语法规范指南](objective-c-style-guide.md)
    * [代码结构规范](code-structure.md)
    * [代码注释规范](code-comments.md)
    * [切图命名规范](naming-cutImage.md)   
    * [崩溃日志的获取](crash_log.md)   
    * [崩溃日志的查看](crash.md)   
* 工具相关
    * [Git基本使用](git-basic.md)   
    * [CocoasPod安装基本使用](cocoasPod-basic.md)   
    * [webP格式](webP.md)    
    * [JSPatch 热更新](http://jspatch.com/Docs/intro)   
* [附录一 Xcode插件](xcode-plugins.md)
* [附录二 常用第三方开源库](library.md)
* [附录二 github开源贡献知识](open_source.md)
* [附录二 知名企业github地址](github_url.md)
* [参考](reference.md)
